//---------------------------------------------------------------------------
#ifndef ValidAreaH
#define ValidAreaH

#define DESL_X1 10
#define DESL_X2 20
#define DESL_Y1 10
#define DESL_Y2 65


// Coordenadas da bobina real
#define BOB_X1 0
#define BOB_X2 500
#define BOB_Y1 0
#define BOB_Y2 100

#define MAX_BOB 3000
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Menus.hpp>
#include <stdio.h>
#include <stdlib.h>

struct sdefeito {

  int x1, x2, y1, y2;

  struct sdefeito *prox;

};

enum eestado {inicio, final, inicio_bobina, final_bobina};

struct shorizontal {

  int coordh;

  eestado estado;

  struct shorizontal *prox, *prev;

  struct svertical *idefv, *fdefv; // inicio ou final defeito vertical

};

struct svertical {

  int coordv;

  int acumulado;

  struct shorizontal *inicio_acumulado;

  struct svertical *prox, *prev;

};

struct ssolucao {

  struct svertical *inicio, *final;

  struct shorizontal *comeco, *atual;

  bool ativa;

  struct ssolucao *prox;

};

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TMainMenu *MainMenu1;
	TMenuItem *Arquivo;
	TMenuItem *Ler1;
	TMenuItem *Salvar1;
	TMenuItem *Sair1;
	TMenuItem *Opes1;
	TMenuItem *Executar1;
	TMenuItem *Limpar1;
	TMenuItem *Restaurar1;
	TMenuItem *Opes2;
	TMenuItem *Refresh1;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormPaint(TObject *Sender);
	
	void __fastcall FormResize(TObject *Sender);
	void __fastcall Ler1Click(TObject *Sender);

	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall Sair1Click(TObject *Sender);

	void __fastcall Salvar1Click(TObject *Sender);
	void __fastcall Executar1Click(TObject *Sender);
	void __fastcall Limpar1Click(TObject *Sender);
	
	
	
	void __fastcall FormMouseUp(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y);
	void __fastcall FormMouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y);
	
	
	
	void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
	
	void __fastcall Restaurar1Click(TObject *Sender);
	void __fastcall Refresh1Click(TObject *Sender);
private:	// User declarations

 sdefeito *defeito;

 shorizontal *h;

 svertical *v;

 ssolucao *conjsol;

 ssolucao *melhor;

 // Coordenada da bobina na tela
 int sbob_x1, sbob_x2, sbob_y1, sbob_y2;

public:		// User declarations
   	 __fastcall TForm1(TComponent* Owner);

};
//---------------------------------------------------------------------------
extern TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
